#ifndef STACK_HPP
#define STACK_HPP

#include <cstddef>

// Linked list based stack after Sedgewick and Wayne, Algorithms 4th ed, Algorithm 1.2

template <typename T>
class Stack {

private:

    ////////////////////////////////////
    class Node {
    public:
        T item;
        Node *next;
        };


public:

    ////////////////////////////////////
    class iterator;
    friend class iterator;
    class iterator {

    public:

        iterator( Node *c );

        iterator& operator++();
        iterator operator++(int);

        T operator*();
        bool operator!=( typename Stack<T>::iterator );

    private:

        Node *curr;
        };

    ////////////////////////////////////

    Stack( void );
    ~Stack( void );

    void push( T &item );
    T pop( void );

    bool is_empty( void );
    size_t size( void );

    iterator begin( void );
    iterator end( void );

#ifdef EXERCISES

    T delete_bottom( void );    // 1.3.19
    T remove( size_t k );       // 1.3.20
    bool find( T key );         // 1.3.21

#endif

private:

    size_t N;
    Node *list;

    };



#endif

