#ifndef STEQUE_HPP
#define STEQUE_HPP

#include <cstddef>

// Linked list based steque after Sedgewick and Wayne, Algorithms 4th ed, Algorithm 1.2

template <typename T>
class Steque {

private:

    ////////////////////////////////////
    class Node {
    public:
        T item;
        Node *next;
        };


public:

    ////////////////////////////////////
    class iterator;
    friend class iterator;
    class iterator {

    public:

        iterator( Node *c );

        iterator& operator++();
        iterator operator++(int);

        T operator*();
        bool operator!=( typename Steque<T>::iterator );

    private:

        Node *curr;
        };

    ////////////////////////////////////

    Steque( void );
    ~Steque( void );

    void push( T &item );
    T pop( void );
    void enqueue( T &item );

    bool is_empty( void );
    size_t size( void );

    iterator begin( void );
    iterator end( void );

private:

    size_t N;
    Node *list;

    };



#endif

